#include "stdafx.h"
#include "LawlPong.h"
#define KEYDOWN(vkcode) (GetAsyncKeyState(vkcode) & 0x8000 ? true : false)


lGame::lGame()
{

}
lGame::~lGame()
{
	lGame::GameShutdown();
}
void lGame::BallAdjust(HWND hWnd, BOOL theme)
{
	RECT rClient;
	GetClientRect(hWnd, &rClient);
	if(theme == TRUE)
	{
		SetRect(&lp.lBall, rClient.right / 2, rClient.bottom / 2,
			 rClient.right / 2 + lp.rawr.bmBallInfo.bmWidth / 4, rClient.bottom / 2 - 5 + lp.rawr.bmBallInfo.bmHeight - 5);
	}
	else
		SetRect(&lp.lBall, rClient.right / 2, rClient.bottom / 2, rClient.right/2 + 20, rClient.bottom/2 + 20);
}

void lGame::GameResize(HWND hWnd)
{
	RECT rClient;
	GetClientRect(hWnd, &rClient);

	lGame::BallAdjust(hWnd, lp.theme);
	
	SetRect(&lp.lPad1, 0, rClient.bottom / 2 - 50, 25, rClient.bottom/2 + 50);
	SetRect(&lp.lPad2, rClient.right - 25, rClient.bottom / 2 - 50, rClient.right, rClient.bottom/2 +50);
}
void lGame::GameReset(HWND hWnd)
{
	lp.lS1 = 0;
	lp.lS2 = 0;
	lp.lBvec.cx = 1;
	lp.lBvec.cy = 1;
	
	RECT rClient;
	GetClientRect(hWnd, &rClient);

	//load Game resources
	lp.hWnd = hWnd;
	//initialize game components -- GameReset
	
	SetRect(&lp.lPad1, 0, rClient.bottom/2 - 50, 25, rClient.bottom/2 + 50);
	SetRect(&lp.lPad2, rClient.right - 25,rClient.bottom/2 - 50, rClient.right, rClient.bottom/2 + 50); 
	
	lp.Modified = FALSE;
	lGame::BallAdjust(hWnd, lp.theme);


}
void lGame::GameInit(HWND hWnd, BOOL reset)
{
	if(reset == TRUE)
	{
		lGame::GameReset(hWnd);
		return;
	}
	lpc.Ball = RGB(0,0,0);
	lpc.Paddles = RGB(0,0,0);
	lpc.Ground = RGB(128,128,128);
	lp.lS1 = 0;
	lp.lS2 = 0;
	lp.lAI = FALSE;
	lp.lBvec.cx = 0;
	lp.lBvec.cy = 0;
	lp.lAISpeed = .75;
	
	RECT rClient;
	GetClientRect(hWnd, &rClient);

	//load Game resources
	lp.hWnd = hWnd;
	//initialize game components -- GameReset
	SetRect(&lp.lPad1, 0, rClient.bottom/2-50, 25, rClient.bottom/2 +50);
	SetRect(&lp.lPad2, rClient.right-25,rClient.bottom/2-50,rClient.right, rClient.bottom/2 +50); 
	lp.theme = FALSE;
	lp.Modified = FALSE;
	lp.Sound = FALSE;
	lGame::BallAdjust(hWnd, lp.theme);


	
}
void lGame::GameMain(HWND hWnd)
{
	HDC hdc;
	HDC hdcMemory;
	HBITMAP hbmBackBuffer;
	HBITMAP hbmOld;
	RECT rClient;
	GetClientRect(hWnd, &rClient);
	lp.Minimized = IsIconic(hWnd);
	
	/*DWORD dwTime = GetTickCount();
	if(GetTickCount() - dwTime > 1000)
	{
	}*/

	//get user input
	if(lp.lAI == TRUE)
	{
		if(lp.lPad2.top > rClient.top && lp.lBall.top < lp.lPad2.top)
			{
				if(lp.lBall.right > rClient.right * lp.lAISpeed && lp.lBvec.cx > 0)
				{
					lp.lPad2.top -=1;
					lp.lPad2.bottom -=1;
				}
			}
		if(lp.lPad2.bottom < rClient.bottom && lp.lBall.bottom > lp.lPad2.bottom)
			{
				if(lp.lBall.right > rClient.right * lp.lAISpeed && lp.lBvec.cx > 0)
				{
					lp.lPad2.top +=1;
					lp.lPad2.bottom +=1;
				}
			}
	}
	else
	{
		if(KEYDOWN(VK_UP))
		{
			if(lp.lPad2.top > rClient.top)
			{
				lp.lPad2.top -=1;
				lp.lPad2.bottom -=1;
			}
		}
		if(KEYDOWN(VK_DOWN))
		{
			if(lp.lPad2.bottom < rClient.bottom)
			{
				lp.lPad2.top +=1;
				lp.lPad2.bottom +=1;
			}

		}
	}
		
	if(KEYDOWN('W'))
	{
		if(lp.lPad1.top > rClient.top)
		{
			lp.lPad1.top -=1;
			lp.lPad1.bottom -=1;
		}
	}
	if(KEYDOWN('S'))
	{
		if(lp.lPad1.bottom < rClient.bottom)
		{
			lp.lPad1.top +=1;
			lp.lPad1.bottom +=1;
		}
	}



	//simulate physics
	if(lp.Minimized == FALSE)
	{
		lp.lBall.left += lp.lBvec.cx;
		lp.lBall.right += lp.lBvec.cx;
		lp.lBall.top += lp.lBvec.cy;
		lp.lBall.bottom += lp.lBvec.cy;
		if(lp.lBvec.cx < 0)
		{
			RECT LawlIntersect1;
			if(IntersectRect(&LawlIntersect1, &lp.lBall, &lp.lPad1))
			{
				if(lp.Sound == TRUE)
					Beep(1000, 10);
				lp.lBvec.cx *= -1;
			}
		}
		if(lp.lBvec.cx > 0)
		{
			RECT LawlIntersect2;
			if(IntersectRect(&LawlIntersect2, &lp.lBall, &lp.lPad2))
			{
				if(lp.Sound == TRUE)
					Beep(1000, 10);
				lp.lBvec.cx *= -1;
			}
		}
		if(lp.lBall.bottom > rClient.bottom)
		{
			if(lp.Sound == TRUE)
				Beep(500, 10);
			lp.lBvec.cy *= -1;
		}
		if(lp.lBall.top < rClient.top)
		{
			if(lp.Sound == TRUE)
				Beep(500, 10);
			lp.lBvec.cy *= -1;
		}
		if(lp.lBall.left < rClient.left)
		{
			if(lp.lS2 < 10)
			{
				if(lp.Sound == TRUE)
				{
					Beep(500, 10);
					Beep(1000, 10);
					Beep(1500, 10);
				}
				lp.lBvec.cx *= -1;
				lp.lS2++;
				lp.Modified = TRUE;
				InvalidateRect(hWnd, NULL, TRUE);
			}
			if(lp.lS2 >= 10)
			{
				if(IDYES == MessageBox(hWnd, _T("Would you like to play again?"), _T("Right Paddle Wins!"), MB_YESNO))
					GameInit(hWnd, TRUE);
				else
				{
					lp.lBvec.cx = 0;
					lp.lBvec.cy = 0;
				}
			}
		}
		if(lp.lBall.right > rClient.right )
		{
			if(lp.lS1 < 10)
			{
				if(lp.Sound == TRUE)
				{
					Beep(500, 10);
					Beep(1000, 10);
					Beep(1500, 10);
				}
				lp.lBvec.cx *= -1;
				lp.lS1++;
				lp.Modified = TRUE;
				InvalidateRect(hWnd, NULL, TRUE);
			}
			if(lp.lS1 >= 10)
			{
				/*lp.lBvec.cx = 0;
				lp.lBvec.cy = 0;*/
				if(IDYES == MessageBox(hWnd, _T("Would you like to play again?"), _T("Left Paddle Wins!"), MB_YESNO))
					GameInit(hWnd, TRUE);
				else
				{
					lp.lBvec.cx = 0;
					lp.lBvec.cy = 0;
				}
				
			}
		}
	}

	//simulate collisiions

	//render game components
	hdc = GetDC(hWnd);
	hdcMemory = CreateCompatibleDC(hdc);
	hbmBackBuffer = CreateCompatibleBitmap(hdc, rClient.right, rClient.bottom);
	hbmOld = (HBITMAP) SelectObject(hdcMemory, hbmBackBuffer);
	HBRUSH Pad, Ball, Back;
	Pad = CreateSolidBrush(lpc.Paddles);
	Ball = CreateSolidBrush(lpc.Ball);
	Back = CreateSolidBrush(lpc.Ground);

	// Render a bitmap (stretched)
	if(lp.theme == TRUE)
	{
		lp.rawr.hdcBackground = CreateCompatibleDC(hdc);
		lp.rawr.hbmBGOld = (HBITMAP)SelectObject(lp.rawr.hdcBackground, lp.rawr.hbmBG);

		SetStretchBltMode(hdcMemory, COLORONCOLOR);
		StretchBlt(hdcMemory, 0, 0, rClient.right, rClient.bottom,
			lp.rawr.hdcBackground, 0, 0, lp.rawr.bmBGInfo.bmWidth, lp.rawr.bmBGInfo.bmHeight, SRCCOPY);

		SelectObject(lp.rawr.hdcBackground, lp.rawr.hbmBGOld);

	}
	else
		FillRect(hdcMemory, &rClient, Back);

	if(lp.theme == TRUE)
	{
		lp.rawr.hdcBall = CreateCompatibleDC(hdc);
		lp.rawr.hbmBallOld = (HBITMAP)SelectObject(lp.rawr.hdcBall, lp.rawr.hbmBall);

		if(lp.lBvec.cx == -1 && lp.lBvec.cy == -1)
		{
			TransparentBlt(hdcMemory, lp.lBall.left, lp.lBall.top, lp.rawr.bmBallInfo.bmWidth/4,
				lp.rawr.bmBallInfo.bmHeight, lp.rawr.hdcBall, 0, 0, lp.rawr.bmBallInfo.bmWidth/4, lp.rawr.bmBallInfo.bmHeight,
			RGB(0,0,0));
		}
		if(lp.lBvec.cx == -1 && lp.lBvec.cy == 1)
		{
			TransparentBlt(hdcMemory, lp.lBall.left, lp.lBall.top, lp.rawr.bmBallInfo.bmWidth/4,
				lp.rawr.bmBallInfo.bmHeight, lp.rawr.hdcBall, lp.rawr.bmBallInfo.bmWidth/4*1, 0, lp.rawr.bmBallInfo.bmWidth/4, lp.rawr.bmBallInfo.bmHeight,
			RGB(0,0,0));
		}if(lp.lBvec.cx == 1 && lp.lBvec.cy == -1)
		{
			TransparentBlt(hdcMemory, lp.lBall.left, lp.lBall.top, lp.rawr.bmBallInfo.bmWidth/4,
				lp.rawr.bmBallInfo.bmHeight, lp.rawr.hdcBall, lp.rawr.bmBallInfo.bmWidth/4*2, 0, lp.rawr.bmBallInfo.bmWidth/4, lp.rawr.bmBallInfo.bmHeight,
			RGB(0,0,0));
		}if(lp.lBvec.cx == 1 && lp.lBvec.cy == 1)
		{
			TransparentBlt(hdcMemory, lp.lBall.left, lp.lBall.top, lp.rawr.bmBallInfo.bmWidth/4,
				lp.rawr.bmBallInfo.bmHeight, lp.rawr.hdcBall, lp.rawr.bmBallInfo.bmWidth/4*3, 0, lp.rawr.bmBallInfo.bmWidth/4, lp.rawr.bmBallInfo.bmHeight,
			RGB(0,0,0));
		}
		SelectObject(lp.rawr.hdcBall, lp.rawr.hbmBallOld);

	}
	else
	{
		SelectObject(hdcMemory, Ball);
		Ellipse(hdcMemory, lp.lBall.left, lp.lBall.top, lp.lBall.right, lp.lBall.bottom);
	}
	SelectObject(hdcMemory, Pad);
	Rectangle(hdcMemory, lp.lPad1.left, lp.lPad1.top, lp.lPad1.right, lp.lPad1.bottom);
	Rectangle(hdcMemory, lp.lPad2.left, lp.lPad2.top, lp.lPad2.right, lp.lPad2.bottom);
	
	TCHAR LawlBuffer[10];
	wsprintf(LawlBuffer, _T("%i : %i"), lp.lS1, lp.lS2);

	SetBkMode(hdcMemory,TRANSPARENT);
	SetTextColor(hdcMemory, lpc.Paddles);

	TextOut(hdcMemory, rClient.right/2-10, 0, LawlBuffer, lstrlen(LawlBuffer));

	BitBlt(hdc, 0,0,rClient.right,rClient.bottom,hdcMemory,0,0,SRCCOPY);

	SelectObject(hdcMemory, hbmOld);
	DeleteDC(lp.rawr.hdcBackground);
	DeleteDC(lp.rawr.hdcBall);
	DeleteObject(Pad);
	DeleteObject(Ball);
	DeleteObject(Back);
	DeleteObject(hbmBackBuffer);
	DeleteDC(hdcMemory);
	ReleaseDC(hWnd, hdc);
	Sleep(1);
}
void lGame::GameShutdown(void)
{
	//unload game resources
}
