// PONG.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "PONG.h"
#include "LawlPong.h"
#pragma comment (lib, "msimg32.lib")

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name
HWND hWnd;										// the main window handle

lGame lPong;


// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
void SetWindowTitle(LPCTSTR szFileName);
BOOL ClearDocument();
void OnFileNew(HWND);
void OnFileOpen(HWND);
void OnFileSaveAs(HWND);
void OnFileSave(HWND);
void OnFileClose(HWND);


int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_PONG, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_PONG));
	//game launch
	
	lPong.GameInit(hWnd, FALSE);
	while(true)
	{
		//OS
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			if(msg.message == WM_QUIT)
				break;

			if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		else
		{
			lPong.GameMain(hWnd);
			//get user input

			//Simulate physics, collisions, AI
			
			//Render Game Components
		}
		
	}

	//game nukeing
	lPong.GameShutdown();

	//// Main message loop: Event Driven
	//while (GetMessage(&msg, NULL, 0, 0))
	//{
	//	if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
	//	{
	//		TranslateMessage(&msg);
	//		DispatchMessage(&msg);
	//	}
	//}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_PONG));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_PONG);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
  

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, 800, 600, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }


	CheckMenuItem(GetMenu(hWnd), ID_AI_ON, MF_UNCHECKED);
	CheckMenuItem(GetMenu(hWnd), ID_AI_OFF, MF_CHECKED);
	CheckMenuItem(GetMenu(hWnd), ID_COLORS_NORMAL, MF_CHECKED);
	CheckMenuItem(GetMenu(hWnd), ID_COLORS_ARCANE, MF_UNCHECKED);
	CheckMenuItem(GetMenu(hWnd), ID_COLORS_FIRE, MF_UNCHECKED);
	CheckMenuItem(GetMenu(hWnd), ID_COLORS_FROST, MF_UNCHECKED);
	CheckMenuItem(GetMenu(hWnd), ID_COLORS_SHADOW, MF_UNCHECKED);
	CheckMenuItem(GetMenu(hWnd), ID_AI_EASY, MF_CHECKED);
	CheckMenuItem(GetMenu(hWnd), ID_AI_HARD, MF_UNCHECKED);
	CheckMenuItem(GetMenu(hWnd), ID_SOUND_ON, MF_UNCHECKED);
	CheckMenuItem(GetMenu(hWnd), ID_SOUND_OFF, MF_CHECKED);

   wsprintf(lPong.lp.lFileName, _T("Untitled"));
   SetWindowTitle(lPong.lp.lFileName);
   //lPong.
   ShowWindow(hWnd, nCmdShow);
   //UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case ID_FILE_NEW:
			OnFileNew(hWnd);
			break;
		case ID_FILE_OPEN:
			OnFileOpen(hWnd);
			break;
		case ID_FILE_SAVE:
			OnFileSave(hWnd);
			break;
		case ID_FILE_SAVEAS:
			OnFileSaveAs(hWnd);
			break;
		case ID_COLORS_NORMAL:
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_NORMAL, MF_CHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_ARCANE, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_FIRE, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_FROST, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_SHADOW, MF_UNCHECKED);

			lPong.lpc.Ball = RGB(0,0,0);
			lPong.lpc.Ground = RGB (128,128,128);
			lPong.lpc.Paddles = RGB(0,0,0);
			lPong.lp.theme = FALSE;
			lPong.BallAdjust(hWnd, lPong.lp.theme);
			break;
		case ID_COLORS_ARCANE:
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_NORMAL, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_ARCANE, MF_CHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_FIRE, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_FROST, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_SHADOW, MF_UNCHECKED);

			lPong.lpc.Paddles = RGB(115,64,115);
			lPong.lp.rawr.hbmBG = (HBITMAP)LoadImage(NULL, _T("LawlArcaneBG.bmp"),
			IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
			if( ! lPong.lp.rawr.hbmBG)
			{
				MessageBox(hWnd, _T("File not found: LawlArcaneBG.bmp"),
					szTitle, MB_ICONERROR);
			}
			// Get information (width, height) about the bitmap at runtime.
			GetObject(lPong.lp.rawr.hbmBG, sizeof(BITMAP), &lPong.lp.rawr.bmBGInfo);

			lPong.lp.rawr.hbmBall = (HBITMAP)LoadImage(NULL, _T("LawlArcane.bmp"),
			IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
			if( ! lPong.lp.rawr.hbmBall)
			{
				MessageBox(hWnd, _T("File not found: LawlArcane.bmp"),
					szTitle, MB_ICONERROR);
			}
			// Get information (width, height) about the bitmap at runtime.
			GetObject(lPong.lp.rawr.hbmBall, sizeof(BITMAP), &lPong.lp.rawr.bmBallInfo);

			lPong.lp.theme = TRUE;
			lPong.BallAdjust(hWnd, lPong.lp.theme);

			break;
		case ID_COLORS_FIRE:
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_NORMAL, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_ARCANE, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_FIRE, MF_CHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_FROST, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_SHADOW, MF_UNCHECKED);

			lPong.lpc.Paddles = RGB(252,170,1);
			lPong.lp.rawr.hbmBG = (HBITMAP)LoadImage(NULL, _T("LawlFireBG.bmp"),
			IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
			if( ! lPong.lp.rawr.hbmBG)
			{
				MessageBox(hWnd, _T("File not found: LawlFireBG.bmp"),
					szTitle, MB_ICONERROR);
			}
			// Get information (width, height) about the bitmap at runtime.
			GetObject(lPong.lp.rawr.hbmBG, sizeof(BITMAP), &lPong.lp.rawr.bmBGInfo);

			lPong.lp.rawr.hbmBall = (HBITMAP)LoadImage(NULL, _T("LawlFire.bmp"),
			IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
			if( ! lPong.lp.rawr.hbmBall)
			{
				MessageBox(hWnd, _T("File not found: LawlFire.bmp"),
					szTitle, MB_ICONERROR);
			}
			// Get information (width, height) about the bitmap at runtime.
			GetObject(lPong.lp.rawr.hbmBall, sizeof(BITMAP), &lPong.lp.rawr.bmBallInfo);

			lPong.lp.theme = TRUE;
			lPong.BallAdjust(hWnd, lPong.lp.theme);

			break;
		case ID_COLORS_FROST:   
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_NORMAL, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_ARCANE, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_FIRE, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_FROST, MF_CHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_SHADOW, MF_UNCHECKED);

			lPong.lpc.Paddles = RGB(26,85,145);
			lPong.lp.rawr.hbmBG = (HBITMAP)LoadImage(NULL, _T("LawlFrostBG.bmp"),
			IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
			if( ! lPong.lp.rawr.hbmBG)
			{
				MessageBox(hWnd, _T("File not found: LawlFrostBG.bmp"),
					szTitle, MB_ICONERROR);
			}
			// Get information (width, height) about the bitmap at runtime.
			GetObject(lPong.lp.rawr.hbmBG, sizeof(BITMAP), &lPong.lp.rawr.bmBGInfo);

			lPong.lp.rawr.hbmBall = (HBITMAP)LoadImage(NULL, _T("LawlFrost.bmp"),
			IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
			if( ! lPong.lp.rawr.hbmBall)
			{
				MessageBox(hWnd, _T("File not found: LawlFrost.bmp"),
					szTitle, MB_ICONERROR);
			}
			// Get information (width, height) about the bitmap at runtime.
			GetObject(lPong.lp.rawr.hbmBall, sizeof(BITMAP), &lPong.lp.rawr.bmBallInfo);

			lPong.lp.theme = TRUE;
			lPong.BallAdjust(hWnd, lPong.lp.theme);
			
			break;
		case ID_COLORS_SHADOW:
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_NORMAL, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_ARCANE, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_FIRE, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_FROST, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_COLORS_SHADOW, MF_CHECKED);

			lPong.lpc.Paddles = RGB(0,165,0);
			lPong.lp.rawr.hbmBG = (HBITMAP)LoadImage(NULL, _T("LawlShadowBG.bmp"),
			IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
			if( ! lPong.lp.rawr.hbmBG)
			{
				MessageBox(hWnd, _T("File not found: LawlShadowBG.bmp"),
					szTitle, MB_ICONERROR);
			}
			// Get information (width, height) about the bitmap at runtime.
			GetObject(lPong.lp.rawr.hbmBG, sizeof(BITMAP), &lPong.lp.rawr.bmBGInfo);

			lPong.lp.rawr.hbmBall = (HBITMAP)LoadImage(NULL, _T("LawlShadow.bmp"),
			IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR | LR_LOADFROMFILE);
			if( ! lPong.lp.rawr.hbmBall)
			{
				MessageBox(hWnd, _T("File not found: LawlShadow.bmp"),
					szTitle, MB_ICONERROR);
			}
			// Get information (width, height) about the bitmap at runtime.
			GetObject(lPong.lp.rawr.hbmBall, sizeof(BITMAP), &lPong.lp.rawr.bmBallInfo);

			lPong.lp.theme = TRUE;
			lPong.BallAdjust(hWnd, lPong.lp.theme);

			break;
		case ID_AI_ON:
			lPong.lp.lAI = TRUE;
			CheckMenuItem(GetMenu(hWnd), ID_AI_ON, MF_CHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_AI_OFF, MF_UNCHECKED);
			break;
		case ID_AI_OFF:
			lPong.lp.lAI = FALSE;
			CheckMenuItem(GetMenu(hWnd), ID_AI_ON, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_AI_OFF, MF_CHECKED);
			break;
		case ID_AI_EASY:
			lPong.lp.lAISpeed = .75;
			CheckMenuItem(GetMenu(hWnd), ID_AI_EASY, MF_CHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_AI_HARD, MF_UNCHECKED);
			break;
		case ID_AI_HARD:
			lPong.lp.lAISpeed = .50;
			CheckMenuItem(GetMenu(hWnd), ID_AI_EASY, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_AI_HARD, MF_CHECKED);
			break;
		case ID_SOUND_ON:
			lPong.lp.Sound = TRUE;
			CheckMenuItem(GetMenu(hWnd), ID_SOUND_ON, MF_CHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_SOUND_OFF, MF_UNCHECKED);
			break;
		case ID_SOUND_OFF:
			lPong.lp.Sound = FALSE;
			CheckMenuItem(GetMenu(hWnd), ID_SOUND_ON, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_SOUND_OFF, MF_CHECKED);
			break;
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			OnFileClose(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		lPong.GameMain(hWnd);
		EndPaint(hWnd, &ps);
		break;
	case WM_SIZE:
		lPong.GameResize(hWnd);
		break;
	case WM_ERASEBKGND:
		return true;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	case WM_CLOSE:
		OnFileClose(hWnd);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

void SetWindowTitle(LPCTSTR szFileName)
{
	TCHAR szBuffer[MAX_PATH];

	wsprintf(szBuffer, _T("%s - %s"), szFileName, szTitle);
	SetWindowText(hWnd, szBuffer);
}
BOOL ClearDocument()
{
	/*if(IDYES == MessageBox(hWnd, _T("Do you want to quit your game?"), _T("WTF?"), MB_YESNO))
	{*/
		if(lPong.lp.Modified)
		{
			TCHAR szMessage[MAX_PATH];
			wsprintf(szMessage, _T("Do you want to save %s"), &lPong.lp.lFileName[lPong.lp.offset]);
			int answer = MessageBox(hWnd, szMessage, _T("Clear Document"), MB_YESNOCANCEL);
			switch(answer)
			{
			case IDYES:
				OnFileSave(hWnd);
				break;
			case IDNO:
				break;
			case IDCANCEL:
				return FALSE;
			}			
		}
		return TRUE;
	/*}
	return FALSE;*/
}

void OnFileNew(HWND hWnd)
{
	if(!lPong.lp.winner)
	{
		if(ClearDocument())
		{
			
			SetWindowTitle(_T("Untitled"));
			lPong.lp.Modified = FALSE;
			if(IDYES == MessageBox(hWnd, _T("Would you like to play vs the Computer?"), _T("AI?"), MB_YESNO))
			{
				lPong.GameInit(hWnd, TRUE);
				lPong.lp.lAI = TRUE;
				CheckMenuItem(GetMenu(hWnd), ID_AI_ON, MF_CHECKED);
				CheckMenuItem(GetMenu(hWnd), ID_AI_OFF, MF_UNCHECKED);
			}
			else
			{
				lPong.GameInit(hWnd, TRUE);
				lPong.lp.lAI = FALSE;
				CheckMenuItem(GetMenu(hWnd), ID_AI_ON, MF_UNCHECKED);
				CheckMenuItem(GetMenu(hWnd), ID_AI_OFF, MF_CHECKED);
			}

			InvalidateRect(hWnd, NULL, TRUE);
		}
	}
	else
	{
		
		SetWindowTitle(_T("Untitled"));
		lPong.lp.Modified = FALSE;
		if(IDYES == MessageBox(hWnd, _T("Would you like to play vs the Computer?"), _T("AI?"), MB_YESNO))
		{
			lPong.GameInit(hWnd, TRUE);
			lPong.lp.lAI = TRUE;
			CheckMenuItem(GetMenu(hWnd), ID_AI_ON, MF_CHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_AI_OFF, MF_UNCHECKED);
		}
		else
		{
			lPong.GameInit(hWnd, TRUE);
			lPong.lp.lAI = FALSE;
			CheckMenuItem(GetMenu(hWnd), ID_AI_ON, MF_UNCHECKED);
			CheckMenuItem(GetMenu(hWnd), ID_AI_OFF, MF_CHECKED);
		}
		

		InvalidateRect(hWnd, NULL, TRUE);
	}
	
}

void OnFileOpen(HWND hWnd)
{
	OPENFILENAME ofn;

	ZeroMemory(&ofn, sizeof(ofn));

	ofn.lStructSize = sizeof(ofn);
	ofn.lpstrFile = lPong.lp.lFileName;
	ofn.lpstrFile[0] = 0;
	ofn.nMaxFile = MAX_PATH;

	ofn.lpstrFilter = _T("PONG Files (*.lawl)\0*.lawl\0");
	ofn.nFilterIndex = 1;
	ofn.lpstrDefExt = _T("lawl");
	ofn.Flags = OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST;

	if(GetOpenFileName(&ofn))
	{
		ifstream fin;
		fin.open(lPong.lp.lFileName);
		fin >> lPong.lp.lBall.top;
		fin >> lPong.lp.lBall.left;
		fin >> lPong.lp.lBall.right;
		fin >> lPong.lp.lBall.bottom;
		fin >> lPong.lp.lBvec.cx;
		fin >> lPong.lp.lBvec.cy;
		fin >> lPong.lp.lPad1.top;
		fin >> lPong.lp.lPad1.left;
		fin >> lPong.lp.lPad1.right;
		fin >> lPong.lp.lPad1.bottom;
		fin >> lPong.lp.lPad2.top;
		fin >> lPong.lp.lPad2.left;
		fin >> lPong.lp.lPad2.right;
		fin >> lPong.lp.lPad2.bottom;
		fin >> lPong.lp.lS1;
		fin >> lPong.lp.lS2;
		fin >> lPong.lp.lAI;
		fin.close();
		SetWindowTitle(&lPong.lp.lFileName[ofn.nFileOffset]);
		lPong.lp.offset = ofn.nFileOffset;
		lPong.lp.Modified = FALSE;
		InvalidateRect(hWnd, NULL, TRUE);

	}

}

void OnFileSaveAs(HWND hWnd)
{
	OPENFILENAME ofn;

	ZeroMemory(&ofn, sizeof(ofn));

	ofn.lStructSize = sizeof(ofn);
	ofn.lpstrFile = lPong.lp.lFileName;
	ofn.lpstrFile[0] = 0;
	ofn.nMaxFile = MAX_PATH;

	ofn.lpstrFilter = _T("PONG Files (*.lawl)\0*.lawl\0");
	ofn.nFilterIndex = 1;
	ofn.lpstrDefExt = _T("lawl");
	ofn.Flags = OFN_CREATEPROMPT;

	if(GetSaveFileName(&ofn))
	{
		//open and read in the data here
		ofstream fout;
		fout.open(lPong.lp.lFileName);
		fout << lPong.lp.lBall.top << '\n';
		fout << lPong.lp.lBall.left << '\n';
		fout << lPong.lp.lBall.right << '\n';
		fout << lPong.lp.lBall.bottom << '\n';
		fout << lPong.lp.lBvec.cx << '\n';
		fout << lPong.lp.lBvec.cy << '\n';
		fout << lPong.lp.lPad1.top << '\n';
		fout << lPong.lp.lPad1.left << '\n';
		fout << lPong.lp.lPad1.right << '\n';
		fout << lPong.lp.lPad1.bottom << '\n';
		fout << lPong.lp.lPad2.top << '\n';
		fout << lPong.lp.lPad2.left << '\n';
		fout << lPong.lp.lPad2.right << '\n';
		fout << lPong.lp.lPad2.bottom << '\n';
		fout << lPong.lp.lS1 << '\n';
		fout << lPong.lp.lS2 << '\n';
		fout << lPong.lp.lAI;
		fout.close();
		SetWindowTitle(&lPong.lp.lFileName[ofn.nFileOffset]);
		lPong.lp.offset = ofn.nFileOffset;
		lPong.lp.Modified = FALSE;
		InvalidateRect(hWnd, NULL, TRUE);
	}
}

void OnFileSave(HWND hWnd)
{
	if(lPong.lp.Modified)
	{
		if(!lstrcmp(&lPong.lp.lFileName[lPong.lp.offset], _T("Untitled")))
		{
			OnFileSaveAs(hWnd);
		}
		else
		{
			// Open file and write the data
			ofstream fout;
			fout.open(lPong.lp.lFileName);
			fout << lPong.lp.lBall.top << '\n';
			fout << lPong.lp.lBall.left << '\n';
			fout << lPong.lp.lBall.right << '\n';
			fout << lPong.lp.lBall.bottom << '\n';
			fout << lPong.lp.lBvec.cx << '\n';
			fout << lPong.lp.lBvec.cy << '\n';
			fout << lPong.lp.lPad1.top << '\n';
			fout << lPong.lp.lPad1.left << '\n';
			fout << lPong.lp.lPad1.right << '\n';
			fout << lPong.lp.lPad1.bottom << '\n';
			fout << lPong.lp.lPad2.top << '\n';
			fout << lPong.lp.lPad2.left << '\n';
			fout << lPong.lp.lPad2.right << '\n';
			fout << lPong.lp.lPad2.bottom << '\n';
			fout << lPong.lp.lS1 << '\n';
			fout << lPong.lp.lS2 << '\n';
			fout << lPong.lp.lAI;
			fout.close();
			lPong.lp.Modified = FALSE;
			InvalidateRect(hWnd, NULL, TRUE);
		}
		lPong.lp.Modified = FALSE;
	}
}
void OnFileClose(HWND hWnd)
{
	if(ClearDocument())
	{
		DestroyWindow(hWnd);
	}
}